//+------------------------------------------------------------------+
//|                                       ForexTSD_Calendar_v1.4.mq4 |
//|                                  Copyright  2007, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1  Red

//
//
//
//
//

#include <WebGet.mqh>

#import "kernel32.dll"
void GetLocalTime(int& TimeArray[]);
void GetSystemTime(int& TimeArray[]);
int  GetTimeZoneInformation(int& TZInfoArray[]);
#import

//
//
//
//
//

extern string   CalendarName               = "ForexTSD";
extern int      CalendarID                 = 4;              // Calendar's ID on calendar.forex-tsd.com  
extern bool     UseStartDate               = false; 
extern datetime StartDate                  = D'2007.04.10';      
extern bool     AlertMode                  = false;
extern int      AlertTimeGap               = 1;             // Time Gap between News Time and Alert Time in min 
extern bool     DisplayLine                = false;         // Display Line Option (Visualization mode) 
extern bool     DisplayText                = false;         // Display Text Option (Visualization mode)

extern string   cFilter                    = " Currency Filter ";
extern bool     USD                        = true;
extern bool     EUR                        = true;
extern bool     GBP                        = true;
extern bool     JPY                        = true;
extern bool     AUD                        = true;
extern bool     CAD                        = true;
extern bool     CHF                        = true;
extern bool     NZD                        = true;

extern string rFilter                      = " Rating Filter ";
extern int    MaxRating                    = 3;
extern int    MinRating                    = 1; 

extern string nclock                       = " Clock settings ";
extern string news_parameters              = "Make your selection";
extern color  session_upcoming_title_color = Purple;
extern color  session_closing_color        = Red;
extern color  bar_closing_color            = Green;
extern int    Clockcorner                  = 2;
extern int    godown                       = 0;
extern int    goright                      = 0;
extern color  labelColor                   = DarkSlateGray;
extern color  clockColor                   = DarkSlateGray;
extern color  ClockMktOpenColor            = Red;
extern color  ClockMktHolidayClr           = PaleTurquoise;  // Blue;
extern int    LabelsFontSize               = 8;
extern bool   show12HourTime               = false;          // YOU CAN CHANGE IT BUT I LIKE THIS MORE
extern bool   ShowSpreadChart              = true;
extern bool   ShowBarTime                  = true;
extern bool   ShowLocal                    = true;
extern bool   ShowBroker                   = true;
extern bool   ShowGMT                      = true;
extern bool   Show_NEW_ZEALAND             = true;           // Auckland GMT+12
extern bool   Show_AUSTRALIA               = true;           // Sydney GMT+12
extern bool   Show_JAPAN                   = true;           // Tokyo GMT+9
extern bool   Show_HONG_KONG               = true;           // GMT+8
extern bool   Show_EUROPE                  = true;           // Frankfurt GMT+1
extern bool   Show_LONDON                  = true;           // GMT+0
extern bool   Show_NEW_YORK                = true;           // GMT-5

//
//
//
//
//

string   sDate[1000];          // Date
string   sTime[1000];          // Time
string   sCurrency[1000];      // Currency
string   sDescription[1000];   // Description
string   sRating[1000];        // Rating
string   sActual[1000];        // Actual value
string   sForecast[1000];      // Forecast value
string   sPrevious[1000];      // Previous value
string   sImpact[1000];
string   sComment   = "";
datetime dt[1000];    
int      NewsNum;
bool     fTime;
datetime prevTime, nTime, OpenTime;
int      TimeZone;

double spread;

datetime NZDHoliday = 0;
datetime AUDHoliday = 0;
datetime JPYHoliday = 0;
datetime CNYHoliday = 0;
datetime EURHoliday = 0;
datetime GBPHoliday = 0;
datetime USDHoliday = 0;
datetime localTime; 
double   Buffer1[];

double   _Point = 0;

int      digit; 
int      LondonTZ      = 0;
int      TokyoTZ       = 9;
int      NewYorkTZ     = -5;
int      SydneyTZ      = 11;
int      BerlinTZ      = 1;
int      AucklandTZ    = 13;
int      HongKongTZ    = 8;
int      time_zone_gmt = 2;       //LOCAL TIMEZONE WILL BE CHANGED TO 
                                 //YOUR PC-TIMEZONE AUTOMATICLY
datetime newyork,london,frankfurt,tokyo,sydney,auckland,hongkong,GMT;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
//
//

int init()
{  
   digit = Digits;
   
   
   SetIndexBuffer(0,Buffer1);
   int top = godown+20;
   int left2 = 70+goright;
   int left =left2;
   if (show12HourTime) left = left2-20;
   if (ShowSpreadChart)
   {
      ObjectMakeLabel("Spread Monitor1", left-45, top);
      ObjectMakeLabel("Spread Monitor2", left2+25, top);
      top += 15;
   }      
   if (ShowBarTime)
   {
      ObjectMakeLabel("barl", left2, top);
      ObjectMakeLabel("bart", left-45, top);
      top += 15;
   }     
   top += 5;
   if (ShowLocal) 
   {
      ObjectMakeLabel("locl", left2, top);
      ObjectMakeLabel("loct", left-45, top);
      top += 15;
   }
   if (ShowBroker)
   {
      ObjectMakeLabel("brol", left2, top);
      ObjectMakeLabel("brot", left-45, top);
      top += 15;
   }
   if (ShowGMT)
   {       
      ObjectMakeLabel("gmtl", left2, top);
      ObjectMakeLabel("gmtt", left-45, top);
      top += 15;
   }
   top += 5;
   if (Show_NEW_ZEALAND)
   {
      ObjectMakeLabel("NZDl", left2, top);
      ObjectMakeLabel("NZDt", left-45, top);
      top += 15;      
   }
   if (Show_AUSTRALIA)
   {
      ObjectMakeLabel("sydl", left2, top);
      ObjectMakeLabel("sydt", left-45, top);
      top += 15;      
   }
   if (Show_JAPAN)
   {
      ObjectMakeLabel("tokl", left2, top);
      ObjectMakeLabel("tokt", left-45, top);
      top += 15;      
   }
   if (Show_HONG_KONG)
   {
      ObjectMakeLabel("HKl", left2, top);
      ObjectMakeLabel("HKt", left-45, top);
      top += 15;      
   }            
   if (Show_EUROPE)
   {
      ObjectMakeLabel("berl", left2, top);
      ObjectMakeLabel("bert", left-45, top);
      top += 15;      
   }   
   if (Show_LONDON)
   {
      ObjectMakeLabel("lonl", left2, top);
      ObjectMakeLabel("lont", left-45, top);
      top += 15;      
   }
   if (Show_NEW_YORK)
   {
      ObjectMakeLabel("nyl", left2, top);
      ObjectMakeLabel("nyt", left-45, top);
      top += 15;      
   }
   
   _Point =  MarketInfo(Symbol(),MODE_POINT)*MathPow(10,digit%2);

   CreateInfoObjects(); 
   return(0); 
} 

// -----------------------------------------------------------------------------------------------------------------------------
//
//
//
//

int deinit() 
{ 
   ObjectDelete("locl");
   ObjectDelete("loct");
   ObjectDelete("nyl");
   ObjectDelete("nyt");
   ObjectDelete("gmtl");
   ObjectDelete("gmtt");
   ObjectDelete("berl");
   ObjectDelete("bert");
   ObjectDelete("NZDl");
   ObjectDelete("NZDt");   
   ObjectDelete("lonl");
   ObjectDelete("lont");
   ObjectDelete("tokl");
   ObjectDelete("tokt");
   ObjectDelete("HKl");
   ObjectDelete("HKt");   
   ObjectDelete("sydl");
   ObjectDelete("sydt");   
   ObjectDelete("brol");
   ObjectDelete("brot");
   ObjectDelete("barl");
   ObjectDelete("bart");
   ObjectDelete("Spread Monitor1");
   ObjectDelete("Spread Monitor2");
   
   Comment("");
   
   ObjDel();
   
   DeleteSessionInfoObjects(); 

   DisplaySessionInfo();
   
   fTime = true;

   return(0); 
} 

//
//
//
//
//

int start()
{
    if (!IsDllsAllowed()) {
       Alert( " DLLs are disabled.  To enable tick the checkbox in the Common Tab of indicator" );
     return;
   }
   
   datetime cTime = iTime(NULL,PERIOD_W1,0);
   
   if (fTime || (TimeCurrent() > cTime && cTime > prevTime))
   {
   string gmt = forextsd_com_webget("http://calendar.forex-tsd.com/gmt.php");
   if(gmt!="") datetime gmtime = StrToTime(gmt);
   else return(0);
   
   int tz = NormalizeDouble((TimeCurrent() - gmtime)/3600.0,0);
   if ( tz < 24) TimeZone = tz;
   
      
   string cName = ForexTSD_Calendar();  
      
      if(cName != "")
      {   
      ReadnPlotCalendar(cName);
      fTime = false;
      prevTime = cTime;
      }
      else 
      {
     
      return(0);
      }
  
   }
   
   if(AlertMode && TimeToAlert() && TimeCurrent() > nTime) 
   {
   Alert("Upcoming News! Be ready!"); 
   nTime = TimeCurrent() + AlertTimeGap*60;
   }
   ChartComment();   
   
   //
   //
   //
   //
   //
     
   int    counted_bars = IndicatorCounted();

      
   int    TimeArray[4];
   int    TZInfoArray[43];
   int    nYear,nMonth,nDay,nHour,nMin,nSec,nMilliSec;
   string sMilliSec;
   
   GetLocalTime(TimeArray);

   nYear     = TimeArray[0]&0x0000FFFF;
   nMonth    = TimeArray[0]>>16;
   nDay      = TimeArray[1]>>16;
   nHour     = TimeArray[2]&0x0000FFFF;
   nMin      = TimeArray[2]>>16;
   nSec      = TimeArray[3]&0x0000FFFF;
   nMilliSec = TimeArray[3]>>16;
   string   LocalTimeS = FormatDateTime(nYear,nMonth,nDay,nHour,nMin,nSec);
   datetime localTime  = StrToTime( LocalTimeS );
   //-----------------------------------------------------  
   string GMTs       = TimeToString(GMT);
   string locals     = TimeToString(localTime);
   string londons    = TimeToString(london);
   string frankfurts = TimeToString(frankfurt);
   string tokyos     = TimeToString(tokyo);
   string newyorks   = TimeToString(newyork);
   string sydneys    = TimeToString(sydney);
   string aucklands  = TimeToString(auckland);
   string hongkongs  = TimeToString(hongkong);
   string brokers    = TimeToString(CurTime());
   string bars       = TimeToStr(CurTime() - Time[0], TIME_MINUTES);

   //-----------------------------------------------------
   LondonTZ   = GMT_Offset("LONDON",localTime);    //GBP
   TokyoTZ    = GMT_Offset("TOKYO",localTime);     //JPY
   NewYorkTZ  = GMT_Offset("US",localTime);        //USD
   SydneyTZ   = GMT_Offset("SYDNEY",localTime);    //AUD
   BerlinTZ   = GMT_Offset("FRANKFURT",localTime); //EUR
   AucklandTZ = GMT_Offset("AUCKLAND",localTime);  //NZD
   HongKongTZ = GMT_Offset("HONGKONG",localTime);  //CNY
   //-----------------------------------------------------

   int gmt_shift = 0;
   int dst = GetTimeZoneInformation(TZInfoArray);
   if(dst!= 0) gmt_shift  = TZInfoArray[0];
   if(dst== 2) gmt_shift += TZInfoArray[42];

   GMT           = localTime + gmt_shift * 60;
   
   london        = GMT + 3600 * LondonTZ;
   tokyo         = GMT + 3600 * TokyoTZ;
   newyork       = GMT + 3600 * NewYorkTZ;
   sydney        = GMT + 3600 * SydneyTZ;
   frankfurt     = GMT + 3600 * BerlinTZ;
   auckland      = GMT + 3600 * AucklandTZ;
   hongkong      = GMT + 3600 * HongKongTZ;
   time_zone_gmt = -(gmt_shift/60);   
   
   DisplaySessionInfo(); 
   
   
   if ( ShowLocal ) {
      ObjectSetText( "locl", "Local time", LabelsFontSize , "Arial Black", labelColor );
      ObjectSetText( "loct", locals, LabelsFontSize , "Arial Black", ClockMktOpenColor );
     }
   if ( ShowBroker ) {
      ObjectSetText( "brol", "Broker time", LabelsFontSize , "Arial Black", labelColor );
      ObjectSetText( "brot", brokers, LabelsFontSize , "Arial Black", ClockMktOpenColor );
     }      
   if ( ShowGMT ) {
      ObjectSetText( "gmtl", "GMT", LabelsFontSize , "Arial Black", labelColor );
      ObjectSetText( "gmtt", GMTs, LabelsFontSize , "Arial Black", ClockMktOpenColor );
     }
//--------------------------
   if( Show_NEW_ZEALAND )
   {
    if (NZDHoliday < TimeCurrent())
    {
     if ((auckland > StrToTime ("10:00"))&& (auckland <  StrToTime("16:45"))&& TimeDayOfWeek(auckland) != 0 && TimeDayOfWeek(auckland) != 6)          
          {
           ObjectSetText( "NZDl", "New Zealand ", LabelsFontSize , "Arial Black", ClockMktOpenColor );
           ObjectSetText( "NZDt", aucklands, LabelsFontSize , "Arial Black", ClockMktOpenColor );   
          }
   	 else
          {
           ObjectSetText( "NZDl", "New Zealand ", LabelsFontSize , "Arial Black", labelColor );
           ObjectSetText( "NZDt", aucklands, LabelsFontSize , "Arial Black", clockColor );   
          }
    }
    if (NZDHoliday > TimeCurrent())
          {
           ObjectSetText( "NZDl", "New Zealand market Holiday ", LabelsFontSize , "Arial Black", ClockMktHolidayClr );
           ObjectSetText( "NZDt", aucklands, LabelsFontSize , "Arial Black", ClockMktHolidayClr );   
          }    
   }
//---------------------------
   if ( Show_AUSTRALIA )
   {
    if (AUDHoliday < TimeCurrent())    
   {
    if ((sydney > StrToTime ("10:00"))&& (sydney <  StrToTime("17:00"))&& TimeDayOfWeek(sydney) != 0 && TimeDayOfWeek(sydney) != 6)          
         {
          ObjectSetText( "sydl", "Australia ", LabelsFontSize , "Arial Black", ClockMktOpenColor );   
          ObjectSetText( "sydt", sydneys, LabelsFontSize , "Arial Black", ClockMktOpenColor );
         }
   	else
   	{
       ObjectSetText( "sydl", "Australia ", LabelsFontSize , "Arial Black", labelColor );
       ObjectSetText( "sydt", sydneys, LabelsFontSize , "Arial Black", clockColor );        
   	}
   }
    if (AUDHoliday > TimeCurrent())
          {
           ObjectSetText( "sydl", "Australia market Holiday ", LabelsFontSize , "Arial Black", ClockMktHolidayClr );
           ObjectSetText( "sydt", sydneys, LabelsFontSize , "Arial Black", ClockMktHolidayClr );   
          }    
   }
//---------------------------      
   if ( Show_JAPAN ) 
   {
    if (JPYHoliday < TimeCurrent())
   {
    if ((tokyo > StrToTime ("9:00"))&& (tokyo <  StrToTime("12:30"))&& TimeDayOfWeek(tokyo) != 0 && TimeDayOfWeek(tokyo) != 6)
         {
          ObjectSetText( "tokl", "Japan ", LabelsFontSize , "Arial Black", ClockMktOpenColor );
          ObjectSetText( "tokt", tokyos, LabelsFontSize , "Arial Black", ClockMktOpenColor );   
         }
      else
       if ((tokyo > StrToTime ("14:00"))&& (tokyo <  StrToTime("17:00"))&& TimeDayOfWeek(tokyo) != 0 && TimeDayOfWeek(tokyo) != 6)
         {
          ObjectSetText( "tokl", "Japan ", LabelsFontSize , "Arial Black", ClockMktOpenColor );
          ObjectSetText( "tokt", tokyos, LabelsFontSize , "Arial Black", ClockMktOpenColor );   
         }      
      else
      {
       ObjectSetText( "tokl", "Japan ", LabelsFontSize  , "Arial Black", labelColor );
       ObjectSetText( "tokt", tokyos, LabelsFontSize , "Arial Black", clockColor );   
      }
   }
    if (JPYHoliday > TimeCurrent())
          {
           ObjectSetText( "tokl", "Japan market Holiday ", LabelsFontSize , "Arial Black", ClockMktHolidayClr );
           ObjectSetText( "tokt", tokyos, LabelsFontSize , "Arial Black", ClockMktHolidayClr );   
          }    
   }
//---------------------------         
   if (Show_HONG_KONG) 
   {
    if (CNYHoliday < TimeCurrent())
    {
     if ((hongkong > StrToTime ("10:00"))&& (hongkong <  StrToTime("17:00"))&& TimeDayOfWeek(hongkong) != 0 && TimeDayOfWeek(hongkong) != 6)   
         {
          ObjectSetText( "HKl", "Hong Kong ", LabelsFontSize , "Arial Black", ClockMktOpenColor );
          ObjectSetText( "HKt", hongkongs, LabelsFontSize , "Arial Black", ClockMktOpenColor );   
         }
   	else
   	{         
       ObjectSetText( "HKl", "Hong Kong ", LabelsFontSize , "Arial Black", labelColor );
       ObjectSetText( "HKt", hongkongs, LabelsFontSize , "Arial Black", clockColor );
      }
   }   
    if (CNYHoliday > TimeCurrent())
          {
           ObjectSetText( "HKl", "Hong Kong market Holiday ", LabelsFontSize , "Arial Black", ClockMktHolidayClr );
           ObjectSetText( "HKt", hongkongs, LabelsFontSize , "Arial Black", ClockMktHolidayClr );   
          }    
   }
//---------------------------   
   if (Show_EUROPE)
   {
    if (EURHoliday < TimeCurrent())
   {
    if ((frankfurt > StrToTime ("9:00"))&& (frankfurt <  StrToTime("17:30"))&& TimeDayOfWeek(frankfurt) != 0 && TimeDayOfWeek(frankfurt) != 6)
         {
          ObjectSetText( "berl", "Europe ", LabelsFontSize , "Arial Black", ClockMktOpenColor );
          ObjectSetText( "bert", frankfurts, LabelsFontSize , "Arial Black", ClockMktOpenColor );   
         }
   	else
   	{
       ObjectSetText( "berl", "Europe ", LabelsFontSize , "Arial Black", labelColor );
       ObjectSetText( "bert", frankfurts, LabelsFontSize , "Arial Black", clockColor );   
   	}
   }   
    if (EURHoliday > TimeCurrent())
          {
           ObjectSetText( "berl", "European market Holiday ", LabelsFontSize , "Arial Black", ClockMktHolidayClr );
           ObjectSetText( "bert", frankfurts, LabelsFontSize , "Arial Black", ClockMktHolidayClr );   
          }    
   }
//---------------------------      
   if (Show_LONDON)
   {
    if (GBPHoliday < TimeCurrent())
   {
    if ((london > StrToTime ("8:00"))&& (london <  StrToTime("17:00"))&& TimeDayOfWeek(london) != 0 && TimeDayOfWeek(london) != 6)          
         {
          ObjectSetText( "lonl", "UK ", LabelsFontSize , "Arial Black",ClockMktOpenColor );
          ObjectSetText( "lont", londons, LabelsFontSize , "Arial Black",ClockMktOpenColor );   
         }
   	else
   	{
       ObjectSetText( "lonl", "UK ", LabelsFontSize , "Arial Black", labelColor );
       ObjectSetText( "lont", londons, LabelsFontSize , "Arial Black", clockColor );  
   	}
   }
    if (GBPHoliday > TimeCurrent())
          {
           ObjectSetText( "lonl", "London market Holiday ", LabelsFontSize , "Arial Black", ClockMktHolidayClr );
           ObjectSetText( "lont", londons, LabelsFontSize , "Arial Black", ClockMktHolidayClr );   
          }    
   }
//---------------------------               
   if (Show_NEW_YORK)
   {
    if (USDHoliday < TimeCurrent())
   {
    if ((newyork > StrToTime ("8:00"))&& (newyork <  StrToTime("17:00"))&& TimeDayOfWeek(newyork) != 0 && TimeDayOfWeek(newyork) != 6)          
         {
          ObjectSetText( "nyl", "North America ", LabelsFontSize , "Arial Black",ClockMktOpenColor );
          ObjectSetText( "nyt", newyorks, LabelsFontSize , "Arial Black",ClockMktOpenColor );   
         }
   	else
   	{
       ObjectSetText( "nyl", "North America ", LabelsFontSize , "Arial Black", labelColor );
       ObjectSetText( "nyt", newyorks, LabelsFontSize , "Arial Black", clockColor ); 
   	}
   }
    if (USDHoliday > TimeCurrent())
          {
           ObjectSetText( "nyl", "New York market Holiday ", LabelsFontSize , "Arial Black", ClockMktHolidayClr );
           ObjectSetText( "nyt", newyorks, LabelsFontSize , "Arial Black", ClockMktHolidayClr );   
          }    
   }
                
         
   ObjectSetText( "barl", "Bar time", LabelsFontSize , "Arial Black", labelColor );
   ObjectSetText( "bart", bars, LabelsFontSize , "Arial Black", clockColor );
   spread = NormalizeDouble((Ask - Bid)/_Point,2.00);
   ObjectSetText("Spread Monitor1", "Spread ", LabelsFontSize , "Arial Black", labelColor);
   ObjectSetText("Spread Monitor2", DoubleToStr(spread, 2.00), LabelsFontSize , "Arial Black", clockColor);    
   
   return(0);
}

//
//
//
//
//

void ReadnPlotCalendar(string fName)
{    
   int i,handle;
   bool rates=false;
     
   handle=FileOpen(fName,FILE_CSV|FILE_READ,';');
      if(handle<1)
      {
      Print("File not found ", GetLastError());
      return(false);
      }
      
   i=0;
   while(!FileIsEnding(handle))
   {
   sDate[i]        = FileReadString(handle);          
   sTime[i]        = FileReadString(handle);         
   sCurrency[i]    = FileReadString(handle);      
   sDescription[i] = FileReadString(handle);   
   sRating[i]      = FileReadString(handle);        
   sActual[i]      = FileReadString(handle);       
   sForecast[i]    = FileReadString(handle);      
   sPrevious[i]    = FileReadString(handle);                
   
   int rating      = StrToInteger(sRating[i]);
   rates = rating <= MaxRating && rating >= MinRating;
      
   if(!rates) continue;  
   
   if ((sCurrency[i] == "USD") && (!USD)) continue;            
   if ((sCurrency[i] == "EUR") && (!EUR)) continue;            
   if ((sCurrency[i] == "GBP") && (!GBP)) continue;                      
   if ((sCurrency[i] == "JPY") && (!JPY)) continue;
   if ((sCurrency[i] == "AUD") && (!AUD)) continue;
   if ((sCurrency[i] == "CAD") && (!CAD)) continue;                     
   if ((sCurrency[i] == "CHF") && (!CHF)) continue;  
   if ((sCurrency[i] == "NZD") && (!NZD)) continue;   
      
   dt[i] = StrToTime(sDate[i]+" "+sTime[i])+TimeZone*3600;
   if(rating == 3) sImpact[i] = "High";
   if(rating == 2) sImpact[i] = "Medium";
   if(rating == 1) sImpact[i] = "Low";
   
   string info = i+"_"+TimeToStr(dt[i])+" "+sCurrency[i]+" "+" "+sDescription[i]+" "+sImpact[i];
   
   
   color c=Yellow ;
   
   if (sCurrency[i] == "USD") c = Blue;  
   if (sCurrency[i] == "EUR") c = Pink; 
   if (sCurrency[i] == "GBP") c = Red;
   if (sCurrency[i] == "JPY") c = Orange;            
   if (sCurrency[i] == "AUD") c = Green;       
   if (sCurrency[i] == "CAD") c = Gray;
   if (sCurrency[i] == "CHF") c = Green;
   if (sCurrency[i] == "NZD") c = Lime;  
      
      if (DisplayText)
      {
      ObjectCreate("TSDT"+i, OBJ_TEXT, 0, dt[i], Close[0]);
      ObjectSet("TSDT"+i, OBJPROP_COLOR, c);          
      ObjectSetText("TSDT"+i,sCurrency[i] + " " + sDescription[i] + " ",8);          
      ObjectSet("TSDT"+i, OBJPROP_ANGLE, 90);          
      }
          
      if (DisplayLine)
      {         
      ObjectCreate("TSDL"+i, OBJ_VLINE, 0, dt[i], Close[0]);
      ObjectSet("TSDL"+i, OBJPROP_COLOR, c);                    
      ObjectSet("TSDL"+i, OBJPROP_STYLE, STYLE_DOT);                    
      ObjectSet("TSDL"+i, OBJPROP_BACK, true);          
      ObjectSetText("TSDL"+i,sDescription[i] + "  ",8);          
      }
      
   i++;
   }
   NewsNum = i;
   
return(0);
}

//
//
//
//
//

void ObjDel()
{
   int _GetLastError;
   if(DisplayLine && DisplayText) int obtotal = 0.5*ObjectsTotal(); else obtotal = ObjectsTotal();
   for ( int i = 0; i < obtotal; i ++ )
   {
      if (DisplayLine)
      if ( !ObjectDelete( StringConcatenate( "TSDL", i ) ) )
      {
      _GetLastError = GetLastError();
   
      }
      
      if (DisplayText)
      if( !ObjectDelete( StringConcatenate( "TSDT", i ) ) )
      {
      _GetLastError = GetLastError();
     
      }
   }
}

//
//
//
//
//

string ForexTSD_Calendar()
{
   if(!UseStartDate)
   datetime StartWeek = iTime(NULL,PERIOD_W1,0);
   else 
   StartWeek = StartDate;
   
   string StartYear  = TimeYear (StartWeek);
   if (TimeMonth(StartWeek)>9) string StartMonth = TimeMonth(StartWeek);
   else StartMonth = "0" + TimeMonth(StartWeek);
   if (TimeDay(StartWeek)>9) string StartDay   = TimeDay(StartWeek);
   else StartDay = "0" + TimeDay(StartWeek);
   
   string StartTime = StartYear + StartMonth + StartDay;  
      
   string WebAdress = "http://calendar.forex-tsd.com/calendar.php?csv=1&date="+StartTime+"&calendar[]="+CalendarID;
   string result = forextsd_com_webget(WebAdress);
      
   if(result != "") 
   {
   string CalName = "ForexTSD_"+StartYear+"-"+StartMonth+"-"+StartDay+".csv";
   
   Print(CalName," is OK");
   
   int handle=FileOpen(CalName,FILE_CSV|FILE_WRITE,';');
         
      if(handle>0)
      {
      FileWrite(handle, result);
      FileClose(handle);
      }
   }
   else CalName = "";
  
   return(CalName);   
}

//
//
//
//
//

void ChartComment()
{
   
   string sp         = "---------------------------------------------------\n";
   string NL         = "\n";
   
   for (int i=0; i<=NewsNum-1; i++)
   { 
      if(TimeCurrent()> dt[i-1] && TimeCurrent() <= dt[i])
      {
      OpenTime = dt[i];
      string upcomNews = sCurrency[i]+" "+sDescription[i]+" Impact=" + sImpact[i]; 
      string upcomTime = TimeToStr(dt[i]);  
         
         if (i-1 >= 0)
         {
         string prevNews = sCurrency[i-1]+" "+sDescription[i-1]+" Impact=" + sImpact[i]; 
         string prevTime = TimeToStr(dt[i-1]);
         }
      }
      
      if(OpenTime > 0 && OpenTime < dt[i])
      {
      string nextNews = sCurrency[i]+" "+sDescription[i]+" Impact=" + sImpact[i];
      string nextTime = TimeToStr(dt[i]);
      break;
      }
   }
      
   sComment = sp;
   sComment = sComment+"ForexTSD Calendar:"+NL;
   
   //if(TimeZone >= 0)
   //sComment = sComment+"Broker\'s Time Zone : GMT + " + TimeZone + NL;
   //else
   //sComment = sComment+"Broker\'s Time Zone : GMT - " + MathAbs(TimeZone) + NL;
   
   sComment = sComment+"NEWS :" + NL;
   sComment = sComment+"Previous = " + prevTime  +" "+prevNews  + NL;
   sComment = sComment+"Upcoming = " + upcomTime +" "+upcomNews + NL;
   sComment = sComment+"Next = " + nextTime +" "+nextNews + NL;
   sComment = sComment+sp;
  
   Comment(sComment);
}      

//
//
//
//
//

bool TimeToAlert()
{
   bool result = false;
   for (int i=0; i<=NewsNum; i++)
   { 
   datetime AlertTime = dt[i] - AlertTimeGap*60;
   
      if((TimeCurrent()>= AlertTime && TimeCurrent() <= AlertTime + 60))
      {result=true; break;}
   }
   return(result);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

string FormatDateTime(int nYear,int nMonth,int nDay,int nHour,int nMin,int nSec)
  {
   string sMonth,sDay,sHour,sMin,sSec;

   sMonth = 100+nMonth;
   sMonth = StringSubstr(sMonth,1);
   sDay   = 100+nDay;
   sDay   = StringSubstr(sDay,1);
   sHour  = 100+nHour;
   sHour  = StringSubstr(sHour,1);
   sMin   = 100+nMin;
   sMin   = StringSubstr(sMin,1);
   sSec   = 100+nSec;
   sSec   = StringSubstr(sSec,1);

   return(StringConcatenate(nYear,".",sMonth,".",sDay," ",sHour,":",sMin,":",sSec));
  }

//
//
//
//
//

int GMT_Offset(string region,datetime dt1)
{
  int r1=0;
  if (region=="LONDON")    
    r1=GMT0(dt1);
  else if (region=="US")        
    r1=GMT_5(dt1);     
  else if (region=="FRANKFURT")        
    r1=GMT1(dt1);
  else if (region=="HONGKONG")        
    r1=GMT8(dt1);        
  else if (region=="TOKYO")        
    r1=GMT9(dt1);      
  else if (region=="SYDNEY")        
    r1=GMT11(dt1);          
  else if (region=="AUCKLAND")        
    r1=GMT12(dt1);   
      
    return (r1);
}

//+------------------------------------------------------------------+
//| London     DST ===  Standard and Summertime setting              |
//+------------------------------------------------------------------+
//
//

int GMT0(datetime dt1)
{

//UK Standard Time = GMT
//UK Summer Time = BST (British Summer time) = GMT+1
//For 2003-2007 inclusive, the summer-time periods begin and end respectively on 
//the following dates at 1.00am Greenwich Mean Time:
//2003: the Sundays of 30 March and 26 October
//2004: the Sundays of 28 March and 31 October
//2005: the Sundays of 27 March and 30 October
//2006: the Sundays of 26 March and 29 October
//2007: the Sundays of 25 March and 28 October
  if ((dt1>last_sunday(TimeYear(dt1),3))&&(dt1<last_sunday(TimeYear(dt1),10)))
   return(1);//summer
  else
   return(0); 
}

//+------------------------------------------------------------------+
//| Frankfurt     DST ===  Standard and Summertime setting           |
//+------------------------------------------------------------------+
//
//

int GMT1(datetime dt1)
{
//Standard Time = GMT +1
//Summer Time = GMT+2
//For 2003-2007 inclusive, the summer-time periods begin and end respectively on 
//the following dates at 1.00am Greenwich Mean Time:
//2003: the Sundays of 30 March and 26 October
//2004: the Sundays of 28 March and 31 October
//2005: the Sundays of 27 March and 30 October
//2006: the Sundays of 26 March and 29 October
//2007: the Sundays of 25 March and 28 October
  if ((dt1>last_sunday(TimeYear(dt1),3))&&(dt1<last_sunday(TimeYear(dt1),10)))
   return(2);//summer
  else
   return(1); 
}

//+------------------------------------------------------------------+
//| New York   US times                                              |
//+------------------------------------------------------------------+
//
//

int GMT_5(datetime dt1)
{

/*US
//-------------------------------------------------------------------
//Eastern Standard Time (EST) = GMT-5
//-------------------------------------------------------------------
//Eastern Daylight Time (EDT) = GMT-4
//-----+--------------------------+----------------------------------
//Year | 	DST Begins 2 a.m.     |     DST Ends 2 a.m.
//1990-|                          |
//2006 |  (First Sunday in April) |	(Last Sunday in October)
//-----+--------------------------+----------------------------------                                  
//-----+--------------------------+----------------------------------
//Year | 	DST Begins 2 a.m.     |     DST Ends 2 a.m.
//2007-|  (Second Sunday in March)|	(First Sunday in November)
//-----+--------------------------+----------------------------------
year     DST begins                 DST ends
2000     zondag, 2 april, 02:00     zondag, 29 oktober, 02:00
2001     zondag, 1 april, 02:00     zondag, 28 oktober, 02:00
2002     zondag, 7 april, 02:00     zondag, 27 oktober, 02:00
2003     zondag, 6 april, 02:00     zondag, 26 oktober, 02:00
2004     zondag, 4 april, 02:00     zondag, 31 oktober, 02:00
2005     zondag, 3 april, 02:00     zondag, 30 oktober, 02:00
2006     zondag, 2 april, 02:00     zondag, 29 oktober, 02:00

2007     zondag, 11 maart, 02:00    zondag, 4 november, 02:00
2008     zondag, 9 maart, 02:00     zondag, 2 november, 02:00
2009     zondag, 8 maart, 02:00     zondag, 1 november, 02:00
2010     zondag, 14 maart, 02:00    zondag, 7 november, 02:00
2011     zondag, 13 maart, 02:00    zondag, 6 november, 02:00
2012     zondag, 11 maart, 02:00    zondag, 4 november, 02:00
2013     zondag, 10 maart, 02:00    zondag, 3 november, 02:00
2014     zondag, 9 maart, 02:00     zondag, 2 november, 02:00
2015     zondag, 8 maart, 02:00     zondag, 1 november, 02:00
2016     zondag, 13 maart, 02:00    zondag, 6 november, 02:00
2017     zondag, 12 maart, 02:00    zondag, 5 november, 02:00
2018     zondag, 11 maart, 02:00    zondag, 4 november, 02:00
2019     zondag, 10 maart, 02:00    zondag, 3 november, 02:00
                                  
*/
 if(TimeYear(dt1)<2007)
   if ((dt1>sunday_number(TimeYear(dt1),4,1))&&(dt1<last_sunday(TimeYear(dt1),10)))
     return(-4);
    else
     return(-5); 
 else
 if(TimeYear(dt1)>=2007) 
   if ((dt1>sunday_number(TimeYear(dt1),3,2))&&(dt1<sunday_number(TimeYear(dt1),11,1)))
     return(-4);
    else
     return(-5); 
     
}
//+------------------------------------------------------------------+
//|  Hong Kong  CNY                                                  |
//+------------------------------------------------------------------+
int GMT8(datetime dt1)
{
   return(8);//standard NO DST =summer=+8
}

//+------------------------------------------------------------------+
//|  Tokyo  JPY                                                      |
//+------------------------------------------------------------------+
int GMT9(datetime dt1)
{
   return(9);//standard NO DST =summer=+9
}

//+------------------------------------------------------------------+
//
//
//
//

int GMT11(datetime dt1)
{

/*+------------------------------------------------------------------+
//|   Sydney    AUD                                                  |
//+------------------------------------------------------------------+
//|   Eastern Standard Time (EST) = GMT+10   No DST                  |
//|   Eastern Daylight Time (EDT) = GMT+11   DST                     |
//+-----+--------------------------+---------------------------------+
year     enddate                       startdate
2000     zondag, 26 maart, 03:00       zondag, 27 augustus, 02:00
2001     zondag, 25 maart, 03:00       zondag, 28 oktober, 02:00
2002     zondag, 31 maart, 03:00       zondag, 27 oktober, 02:00
2003     zondag, 30 maart, 03:00       zondag, 26 oktober, 02:00
2004     zondag, 28 maart, 03:00       zondag, 31 oktober, 02:00
2005     zondag, 27 maart, 03:00       zondag, 30 oktober, 02:00

2006     zondag, 2 april, 03:00        zondag, 29 oktober, 02:00

2007     zondag, 25 maart, 03:00       zondag, 28 oktober, 02:00

2008     zondag, 6 april, 03:00        zondag, 5 oktober, 02:00
2009     zondag, 5 april, 03:00        zondag, 4 oktober, 02:00
2010     zondag, 4 april, 03:00        zondag, 3 oktober, 02:00
2011     zondag, 3 april, 03:00        zondag, 2 oktober, 02:00
2012     zondag, 1 april, 03:00        zondag, 7 oktober, 02:00
2013     zondag, 7 april, 03:00        zondag, 6 oktober, 02:00
2014     zondag, 6 april, 03:00        zondag, 5 oktober, 02:00
2015     zondag, 5 april, 03:00        zondag, 4 oktober, 02:00
2016     zondag, 3 april, 03:00        zondag, 2 oktober, 02:00
2017     zondag, 2 april, 03:00        zondag, 1 oktober, 02:00
2018     zondag, 1 april, 03:00        zondag, 7 oktober, 02:00
2019     zondag, 7 april, 03:00        zondag, 6 oktober, 02:00

//-----+--------------------------+----------------------------------         
*/
 if(TimeYear(dt1)<1996)
   if ((dt1>sunday_number(TimeYear(dt1),3,1))&&(dt1<last_sunday(TimeYear(dt1),10)))
     return(10);
    else
     return(11); 
 else
 if((TimeYear(dt1)>=1996 && TimeYear(dt1)<2008)&&(TimeYear(dt1)!= 2006))
   if ((dt1>last_sunday(TimeYear(dt1),3))&&(dt1<last_sunday(TimeYear(dt1),10)))
     return(10);
    else
     return(11); 
 else
 if(TimeYear(dt1)== 2006)
   if ((dt1>sunday_number(TimeYear(dt1),4,1))&&(dt1<last_sunday(TimeYear(dt1),10)))
     return(10);
    else
     return(11); 
 else
 if(TimeYear(dt1)>=2008)
   if ((dt1>sunday_number(TimeYear(dt1),4,1))&&(dt1<sunday_number(TimeYear(dt1),10,1)))
     return(10);
    else
     return(11); 
}

//+------------------------------------------------------------------+
//
//
//
//

int GMT12(datetime dt1)
{
/*+------------------------------------------------------------------+
//|   New Zealand  Auckland   NZD                                    |
//+------------------------------------------------------------------+
//|   Eastern Standard Time (EST) = GMT+12   No DST                  |
//|   Eastern Daylight Time (EDT) = GMT+13   DST                     |
//+-----+--------------------------+---------------------------------+
year     enddate                       startdate
2000     zondag, 19 maart, 03:00       zondag, 1 oktober, 02:00
2001     zondag, 18 maart, 03:00       zondag, 7 oktober, 02:00
2002     zondag, 17 maart, 03:00       zondag, 6 oktober, 02:00
2003     zondag, 16 maart, 03:00       zondag, 5 oktober, 02:00
2004     zondag, 21 maart, 03:00       zondag, 3 oktober, 02:00
2005     zondag, 20 maart, 03:00       zondag, 2 oktober, 02:00
2006     zondag, 19 maart, 03:00       zondag, 1 oktober, 02:00

2007     zondag, 18 maart, 03:00       zondag, 30 september, 02:00
2008     zondag, 6 april, 03:00        zondag, 28 september, 02:00
2009     zondag, 5 april, 03:00        zondag, 27 september, 02:00
2010     zondag, 4 april, 03:00        zondag, 26 september, 02:00
2011     zondag, 3 april, 03:00        zondag, 25 september, 02:00
2012     zondag, 1 april, 03:00        zondag, 30 september, 02:00
2013     zondag, 7 april, 03:00        zondag, 29 september, 02:00
2014     zondag, 6 april, 03:00        zondag, 28 september, 02:00
2015     zondag, 5 april, 03:00        zondag, 27 september, 02:00
2016     zondag, 3 april, 03:00        zondag, 25 september, 02:00
2017     zondag, 2 april, 03:00        zondag, 24 september, 02:00
2018     zondag, 1 april, 03:00        zondag, 30 september, 02:00
2019     zondag, 7 april, 03:00        zondag, 29 september, 02:00

//-----+--------------------------+----------------------------------         
*/
 if(TimeYear(dt1)<2007)
   if ((dt1>sunday_number(TimeYear(dt1),3,3))&&(dt1<sunday_number(TimeYear(dt1),10,1)))
     return(12);
    else
     return(13); 
 else
 if(TimeYear(dt1)==2007)
   if ((dt1>sunday_number(TimeYear(dt1),3,3))&&(dt1<last_sunday(TimeYear(dt1),9)))
     return(12);
    else
     return(13); 
 else
 if(TimeYear(dt1)> 2007)
   if ((dt1>sunday_number(TimeYear(dt1),4,1))&&(dt1<last_sunday(TimeYear(dt1),10)))
     return(12);
    else
     return(13); 
     
   return(13);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

bool is_leap_year(int year1)
{
 
  if ((MathMod(year1,100)==0) && (MathMod(year1,400)==0))
    return(true);
  else if ((MathMod(year1,100)!=0) && (MathMod(year1,4)==0))  
    return(true);
  else 
    return (false); 
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int n_days(int year1,int month1)
{
  int ndays1;
  if (month1==1)
    ndays1=31;
  else if(month1==2)
  {
    if (is_leap_year(year1))
      ndays1=29;      
    else
      ndays1=28;  
  }    
  else if(month1==3)
    ndays1=31;  
  else if(month1==4)
    ndays1=30;  
  else if(month1==5)//mai
    ndays1=31;  
  else if(month1==6)//iun          
    ndays1=30;  
  else if(month1==7)//iul          
    ndays1=31;  
  else if(month1==8)//aug          
    ndays1=31;  
  else if(month1==9)//sep          
    ndays1=30;  
  else if(month1==10)//oct          
    ndays1=31;  
  else if(month1==11)//nov          
    ndays1=30;  
  else if(month1==12)          
    ndays1=31;  
  
  return(ndays1);

}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

int n_sdays(int year1,int month1)
{
  datetime ddt2;
  int ndays2=n_days(year1,month1);
  int i,nsun1=0;  
  for (i=1;i<=ndays2;i++) 
  {
    ddt2= StrToTime(DoubleToStr(year1,0)+"."+DoubleToStr(month1,0)+"."+DoubleToStr(i,0)+" 00:00");            
    if(TimeDayOfWeek(ddt2)==0)
      nsun1=nsun1+1; 
  }   
  return(nsun1);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

datetime last_sunday(int year1,int month1)
{
  int i,ndays2,nsun1,nsun2;
  datetime dt2,dt3;
  ndays2=n_days(year1,month1);
  nsun2=n_sdays(year1,month1);
  nsun1=0;
  for (i=1;i<=ndays2;i++) 
  {
    dt2= StrToTime(DoubleToStr(year1,0)+"."+DoubleToStr(month1,0)+"."+DoubleToStr(i,0)+" 00:00");                    
    if(TimeDayOfWeek(dt2)==0)
    {       
      nsun1=nsun1+1; 
    }  
    if (nsun1==nsun2) 
    {
      dt3=dt2;  
      break;        
    }  
  }   
  return(dt3);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

datetime sunday_number(int year1,int month1,int sundaycount)
{
  int i,ndays2,nsun1,nsun2;
  datetime dt2,dt3;
  ndays2=n_days(year1,month1);
  nsun2=sundaycount;//n_sdays(year1,month1);
  nsun1=0;
  for (i=1;i<=ndays2;i++) 
  {
    dt2= StrToTime(DoubleToStr(year1,0)+"."+DoubleToStr(month1,0)+"."+DoubleToStr(i,0)+" 00:00");                    
    if(TimeDayOfWeek(dt2)==0)
    {       
      nsun1=nsun1+1; 
    }  
    if (nsun1==nsun2) 
    {
      dt3=dt2;  
      break;        
    }  
  }   
  return(dt3);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//

void DisplaySessionInfo()
{
   string openSessions = "Active sessions: ";
   string closingSession = "";
//----
// info from http://www.2011.worldmarkethours.com/Forex/index1024.htm
// New Zealand/Auckland.............: 10.00 - 16.45   localtimes timezone country
// Australia/Sydney local session...: 10.00 - 17.00
// Japan/Tokyo......................:  9.00 - 12.30    Re-opens  14.00 - 17.00 
// Hong Kong........................: 10.00 - 17.00
// Europe...........................:  9.00 - 17.30
// London local session.............: 08.00 - 17.00
// New York local session...........: 08.00 - 17.00


//New Zealand....: 10.00 - 16.45
if(NZDHoliday < TimeCurrent()){
  if ((auckland > StrToTime ("9:45"))&& (auckland <  StrToTime("10:00"))&& TimeDayOfWeek(auckland) != 0 && TimeDayOfWeek(auckland) != 6)
      {closingSession = "New Zealand opens in " + (60 - TimeMinute(TimeLocal()))+ " mins";}
  if ((auckland > StrToTime ("10:00"))&& (auckland <  StrToTime("16:45"))&& TimeDayOfWeek(auckland) != 0 && TimeDayOfWeek(auckland) != 6)
   {
      openSessions = openSessions + " New Zealand";
      if(TimeHour(auckland) == 16 && TimeMinute(auckland)>14 && TimeMinute(auckland)<45)
       {
         closingSession = "New Zealand closing in " + (45 - TimeMinute(TimeLocal()))+ " mins";
       } 
   }
 }     
//Australia...: 10.00 - 17.00
if(AUDHoliday < TimeCurrent()){   
  if ((sydney > StrToTime ("9:45"))&& (sydney <  StrToTime("10:00"))&& TimeDayOfWeek(sydney) != 0 && TimeDayOfWeek(sydney) != 6)
      {closingSession = "Australia opens in " + (60 - TimeMinute(TimeLocal()))+ " mins";}
  if ((sydney > StrToTime ("10:00"))&& (sydney <  StrToTime("17:00"))&& TimeDayOfWeek(sydney) != 0 && TimeDayOfWeek(sydney) != 6)
   {
       openSessions = openSessions + " Australia";
       if(TimeHour(sydney) == 16 && TimeMinute(sydney)>29)
       {
         closingSession = "Australia closing in " + (60 - TimeMinute(TimeLocal()))+ " mins";
       } 
   }
 }    
//Japan ....:  9.00 - 12.30    Re-opens  14.00 - 17.00
if(JPYHoliday < TimeCurrent()){
   if (tokyo >= StrToTime ("8:45") && tokyo <  StrToTime("9:00") && TimeDayOfWeek(tokyo) > 0 && TimeDayOfWeek(tokyo) < 6 )   
        {closingSession = "Tokyo first session opens in " + (60 - TimeMinute(TimeLocal()))+ " mins";}
   if (TimeHour(tokyo) >= 9 && TimeHour(tokyo) < 17 && TimeDayOfWeek(tokyo) > 0 && TimeDayOfWeek(tokyo) < 6 )
   {   
    if ((tokyo > StrToTime ("9:00"))&& (tokyo <  StrToTime("12:30"))&& TimeDayOfWeek(tokyo) != 0 && TimeDayOfWeek(tokyo) != 6)
       {openSessions = openSessions + " Tokyo";}
    if (tokyo >= StrToTime ("13:45") && tokyo <  StrToTime("14:00") && TimeDayOfWeek(tokyo) > 0 && TimeDayOfWeek(tokyo) < 6 )
       {closingSession = "Tokyo second session opens in " + (60 - TimeMinute(TimeLocal()))+ " mins";}          
    if ((tokyo > StrToTime ("14:00"))&& (tokyo <  StrToTime("17:00"))&& TimeDayOfWeek(tokyo) != 0 && TimeDayOfWeek(tokyo) != 6)       
       {openSessions = openSessions + " Tokyo";}
       if(TimeHour(tokyo) == 16 && TimeMinute(tokyo)>29)
       {
         closingSession = "Tokyo final closing in " + (60 - TimeMinute(TimeLocal()))+ " mins";
       } 
   }
 }     
//Hong Kong..: 10.00 - 17.00
if(CNYHoliday < TimeCurrent()){
    if ((hongkong > StrToTime ("10:00"))&& (hongkong <  StrToTime("17:00"))&& TimeDayOfWeek(hongkong) != 0 && TimeDayOfWeek(hongkong) != 6)
   {
       openSessions = openSessions + " Hong Kong";
       if(TimeHour(hongkong) == 16 && TimeMinute(hongkong)>29)
       {
         closingSession = "Hong Kong closing in " + (60 - TimeMinute(TimeLocal()))+ " mins";
       } 
   }
 }    
//Europe...:  9.00 - 17.30
if(EURHoliday < TimeCurrent()){
   if (frankfurt >= StrToTime ("8:45") && frankfurt <  StrToTime("9:00") && TimeDayOfWeek(london) > 0 && TimeDayOfWeek(london) < 6 )   
        {closingSession = "Europe opens in " + (60 - TimeMinute(TimeLocal()))+ " mins";}
    if ((frankfurt > StrToTime ("9:00"))&& (frankfurt <  StrToTime("17:30"))&& TimeDayOfWeek(frankfurt) != 0 && TimeDayOfWeek(frankfurt) != 6)
   {
       openSessions = openSessions + " Europe";
       if(TimeHour(frankfurt) == 17 && TimeMinute(frankfurt)<30)
       {
         closingSession = "Europe closing in " + (30 - TimeMinute(TimeLocal()))+ " mins";
       } 
   }
 }     
// London....: 08.00 - 17.00
if(GBPHoliday < TimeCurrent()){
   if (london >= StrToTime ("7:45") && london <  StrToTime("8:00") && TimeDayOfWeek(london) > 0 && TimeDayOfWeek(london) < 6 )   
        {closingSession = "London opens in " + (60 - TimeMinute(TimeLocal()))+ " mins";}
   if (TimeHour(london) >= 8 && TimeHour(london) < 17 && TimeDayOfWeek(london) > 0 && TimeDayOfWeek(london) < 6 )
   {      
         openSessions = openSessions + " London";
         if(TimeHour(london) == 16 && TimeMinute(london)>29)
       {
         closingSession = "London closing in " + (60 - TimeMinute(TimeLocal()))+ " mins";
       } 
   }
 }  
// New York....: 08.00 - 17.00
if(USDHoliday < TimeCurrent()){
   if (newyork >= StrToTime ("7:45") && newyork <  StrToTime("8:00") && TimeDayOfWeek(newyork) > 0 && TimeDayOfWeek(newyork) < 6 )   
        {closingSession = "New York opens in " + (60 - TimeMinute(TimeLocal()))+ " mins";}  
   if (TimeHour(newyork) >= 8 && TimeHour(newyork) < 17 && TimeDayOfWeek(newyork) > 0 && TimeDayOfWeek(newyork) < 6 )
   {
       openSessions = openSessions + " New York";
       if(TimeHour(newyork) == 16)
       {
         closingSession = "New York closing in " + (60 - TimeMinute(TimeLocal()))+ " mins";
       } 
   }
 }  
 
 //
 //
 //
 //
 //
   
 string TimeLeft =  TimeToStr( (iTime(NULL,Period(),0)+Period()*60-TimeCurrent( )), TIME_MINUTES|TIME_SECONDS) ;
 
   if(openSessions == "Active sessions: ") openSessions = "Markets Closed";
   ObjectSetText("OpenSessions", openSessions,LabelsFontSize, "Arial Black", session_upcoming_title_color);
   ObjectSetText("BarClosing", "Time to bar close " + TimeLeft, LabelsFontSize , "Arial Black", bar_closing_color);
   ObjectSetText("SessionClosing",closingSession ,LabelsFontSize , "Arial Black", session_closing_color);

}

//+------------------------------------------------------------------+ 
//
//
//
//

void CreateInfoObjects()
{
   ObjectCreate("OpenSessions", OBJ_LABEL, 0, 0, 0, 0, 0);
   ObjectSet("OpenSessions", OBJPROP_CORNER, 1);
   ObjectSet("OpenSessions", OBJPROP_XDISTANCE, 4);
   ObjectSet("OpenSessions", OBJPROP_YDISTANCE, 0);
   ObjectSetText("OpenSessions", "",LabelsFontSize , "Arial Black", session_upcoming_title_color); 
    
   ObjectCreate("SessionClosing", OBJ_LABEL, 0, 0, 0, 0, 0);
   ObjectSet("SessionClosing", OBJPROP_CORNER, 1);
   ObjectSet("SessionClosing", OBJPROP_XDISTANCE, 4);
   ObjectSet("SessionClosing", OBJPROP_YDISTANCE, 15); 
    
   ObjectCreate("BarClosing", OBJ_LABEL, 0, 0, 0, 0, 0);
   ObjectSet("BarClosing", OBJPROP_CORNER, 1);
   ObjectSet("BarClosing", OBJPROP_XDISTANCE, 4);
   ObjectSet("BarClosing", OBJPROP_YDISTANCE,30); 
   ObjectSetText("BarClosing", "", LabelsFontSize , "Arial Black", bar_closing_color);  
}

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//
//
//

void DeleteSessionInfoObjects()
{
   ObjectDelete("OpenSessions");
   ObjectDelete("BarClosing");
   ObjectDelete("SessionClosing");  
}

//+------------------------------------------------------------------+
//
//
//
//

string TimeToString( datetime when ) {
   if ( !show12HourTime )
      return (TimeToStr( when, TIME_MINUTES ));      
   int hour = TimeHour( when );
   int minute = TimeMinute( when );
   
   string ampm = " AM";
   
   string timeStr;
   if ( hour >= 12 ) {
      hour = hour - 12;
      ampm = " PM";
   }
      
   if ( hour == 0 )
      hour = 12;
   timeStr = DoubleToStr( hour, 0 ) + ":";
   if ( minute < 10 )
      timeStr = timeStr + "0";
   timeStr = timeStr + DoubleToStr( minute, 0 );
   timeStr = timeStr + ampm;
   
   return (timeStr);
}

// -----------------------------------------------------------------------------------------------------------------------------
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//

int ObjectMakeLabel( string n, int xoff, int yoff ) {
   ObjectCreate( n, OBJ_LABEL, 0, 0, 0 );
   ObjectSet( n, OBJPROP_CORNER, Clockcorner );
   ObjectSet( n, OBJPROP_XDISTANCE, xoff );
   ObjectSet( n, OBJPROP_YDISTANCE, yoff );
   ObjectSet( n, OBJPROP_BACK, true );
} 




